﻿using System;
using System.Data.Services;
using System.Data.Services.Common;
using System.Diagnostics;
using System.Threading;
using System.Linq.Expressions;
using NorthwindServiceHost.Models;

namespace NorthwindServiceHost.Services
{
	[System.ServiceModel.ServiceBehavior(IncludeExceptionDetailInFaults = true)]
	public class NorthwindService : DataService<northwndEntities>
	{
		public static void InitializeService(DataServiceConfiguration config)
		{
			config.SetEntitySetAccessRule("*", EntitySetRights.All);
			config.DataServiceBehavior.MaxProtocolVersion = DataServiceProtocolVersion.V2;
			config.UseVerboseErrors = true;
		}

		protected override void OnStartProcessingRequest(ProcessRequestArgs args)
		{
			base.OnStartProcessingRequest(args);

			var msg = string.Format("{0}: {1} {2}{3}"
				, DateTime.Now.ToLongTimeString()
				, args.OperationContext.RequestMethod
				, args.IsBatchOperation ? "BATCH " : string.Empty
				, args.OperationContext.AbsoluteRequestUri
				);

			Debug.WriteLine(msg);
			Console.WriteLine(msg);
		}

	}
}
